/**
 * Introduction
 *
 * @title ROV - Easy applications from C
 *
 * @copyright Jason Tribbeck / 7th ARM 1994-2001
 *
 * @authors Jason Tribbeck
 *
 * @file flexdyn.h
 *
 * @type subsystem
 *
 * @description
 *
 * Deprecated. All functionality is in flex.h.
 * @see flex.h
 */

#ifndef __rov_flexdyn
#define __rov_flexdyn


#ifdef __cplusplus
extern "C"
{
#endif

typedef void * * flexdyn_ptr;
typedef void (* flexdyn_reg)(int);

int flexdyn_alloc(flexdyn_ptr, int); /* Allocates memory */
int flexdyn_allocmax(flexdyn_ptr); /* Allocates all available memory */
void flexdyn_free(flexdyn_ptr); /* Deallocates memory */
int flexdyn_extend(flexdyn_ptr, int); 			/* Allocates to new memory requirement	 */
int flexdyn_extendby(flexdyn_ptr, int); 			/* Allocates more memory		 */
void flexdyn_init(int max, char * title); /* Initialise flexdyn */
void flexdyn_register(flexdyn_reg, int); /* Registers a Wimp_SlotExtend routine */
void flexdyn_clear(void); /* Clears all flexdyn allocations */
int flexdyn_max(void); /* Returns maximum allocation size */
void flexdyn_callregister(int, int); /* Calls registered routine i1 with i2 */
int flexdyn_size(flexdyn_ptr); 				/* Returns size of flexdyn block 	 */
void flexdyn_swap(flexdyn_ptr, flexdyn_ptr); /* Swaps the two flexdyn pointers over */
void flexdyn_move(flexdyn_ptr, flexdyn_ptr); /* Moves flexdyn pointer to 2nd pointer */

#define FLEXDYN_PRERESIZE  (0)
#define FLEXDYN_POSTRESIZE (1)

#define FLEXDYN_ALLOC  (0)
#define FLEXDYN_FREE   (1)
#define FLEXDYN_RESIZE (2)
#define FLEXDYN_CLEAR  (3)
#define FLEXDYN_USER   (100)


#ifdef __cplusplus
}
#endif

#endif
